Index: trunk/LMDZ.GENERIC/libf/phystd/sugas_corrk.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/sugas_corrk.F90	(revision 715)
+++ trunk/LMDZ.GENERIC/libf/phystd/sugas_corrk.F90	(revision 716)
@@ -13,4 +13,5 @@
 !     Adapted and generalised from the NASA Ames code by Robin Wordsworth (2009)
 !     Added double gray case by Jeremy Leconte (2012)
+!     New HITRAN continuum data section by RW (2012)
 !
 !     Summary
@@ -25,4 +26,5 @@
       use radcommon_h, only : wrefvar
       use datafile_mod, only: datadir
+
       use gases_h
       use ioipsl_getincom 
@@ -31,4 +33,5 @@
 #include "callkeys.h"
 #include "comcstfi.h"
+
 !==================================================================
 
@@ -38,8 +41,8 @@
       integer L_NGAUSScheck
 
-      character(len=100) :: file_id
-      character(len=300) :: file_path
-
-      !! ALLOCATABLE ARRAYS -- AS 12/2011
+      character(len=200) :: file_id
+      character(len=500) :: file_path
+
+      ! ALLOCATABLE ARRAYS -- AS 12/2011
       REAL*8, DIMENSION(:,:,:,:,:), ALLOCATABLE :: gasi8, gasv8
       character*3,allocatable,DIMENSION(:) :: gastype ! for check with gnom
@@ -48,5 +51,5 @@
       real kappa_IR, kappa_VI
 
-      integer ngas, igas
+      integer ngas, igas, jgas
 
       double precision testcont ! for continuum absorption initialisation
@@ -84,10 +87,5 @@
                 '] has no variable species, exiting.'
          call abort
-      elseif(ngas.eq.2 .and. (.not.varactive) .and. (.not.varfixed))then
-         print*,'You have varactive and varfixed=.false. and the database [', &
-                     corrkdir(1:LEN_TRIM(corrkdir)),           &
-                '] has a variable species.'
-         call abort
-      elseif(ngas.gt.4 .or. ngas.lt.1)then
+      elseif(ngas.gt.5 .or. ngas.lt.1)then
          print*,ngas,' species in database [',               &
                      corrkdir(1:LEN_TRIM(corrkdir)),           &
@@ -96,15 +94,13 @@
       endif 
 
-      if(ngas.gt.3)then
-         print*,'ngas>3, EXPERIMENTAL!'
-      endif
-
+      ! dynamically allocate gastype and read from Q.dat
       IF ( .NOT. ALLOCATED( gastype ) ) ALLOCATE( gastype( ngas ) )
-      do n=1,ngas
-         read(111,*) gastype(n)
-         print*,'Gas ',n,' is ',gastype(n)
+
+      do igas=1,ngas
+         read(111,*) gastype(igas)
+         print*,'Gas ',igas,' is ',gastype(igas)
       enddo
 
-      ! GET array size, load the coefficients
+      ! get array size, load the coefficients
       open(111,file=TRIM(file_path),form='formatted')
       read(111,*) L_REFVAR
@@ -113,10 +109,17 @@
       close(111)
 
+      if(L_REFVAR.gt.1 .and. (.not.varactive) .and. (.not.varfixed))then
+         print*,'You have varactive and varfixed=.false. and the database [', &
+                     corrkdir(1:LEN_TRIM(corrkdir)),           &
+                '] has a variable species.'
+         call abort
+      endif
+
       ! Check that gastype and gnom match
-      do n=1,ngas
-         print*,'Gas ',n,' is ',gnom(n)
-         if(gnom(n).ne.gastype(n))then
-            print*,'Name of a gas in radiative transfer data (',gastype(n),') does not ', &
-                 'match that in gases.def (',gnom(n),'), exiting. You should compare ', &
+      do igas=1,ngas
+         print*,'Gas ',igas,' is ',gnom(igas)
+         if(gnom(igas).ne.gastype(igas))then
+            print*,'Name of a gas in radiative transfer data (',gastype(igas),') does not ', &
+                 'match that in gases.def (',gnom(igas),'), exiting. You should compare ', &
                  'gases.def with Q.dat in your radiative transfer directory.' 
             call abort
@@ -126,5 +129,5 @@
 
       ! display the values
-      print*,'Variable gas mixing ratios:'
+      print*,'Variable gas volume mixing ratios:'
       do n=1,L_REFVAR
          !print*,n,'.',wrefvar(n),' kg/kg' ! pay attention!
@@ -191,5 +194,5 @@
       endif
      
-      ! GET array size, load the coefficients
+      ! get array size, load the coefficients
       open(111,file=TRIM(file_path),form='formatted')
       read(111,*) L_NPREF
@@ -200,5 +203,4 @@
       IF( .NOT. ALLOCATED( pfgasref ) ) ALLOCATE( PFGASREF(L_PINT) )
 
-
       ! display the values
       print*,'Correlated-k pressure grid (mBar):'
@@ -219,5 +221,5 @@
       end do
       pfgasref(L_PINT) = pgasref(L_NPREF)
-      print*,'Warning, pfgasref needs generalisation to uneven grids!!'
+      ! Warning, pfgasref needs generalisation to uneven grids!
 
 !-----------------------------------------------------------------------
@@ -239,5 +241,5 @@
       endif
 
-      ! GET array size, load the coefficients
+      ! get array size, load the coefficients
       open(111,file=TRIM(file_path),form='formatted')
       read(111,*) L_NTREF
@@ -256,15 +258,16 @@
       tgasmax = tgasref(L_NTREF)
 
-
 !-----------------------------------------------------------------------
-!-----------------------------------------------------------------------
-! ALLOCATE THE MULTIDIM ARRAYS IN radcommon_h
-      PRINT *, L_NTREF,L_NPREF,L_REFVAR 
+! allocate the multidimensional arrays in radcommon_h
+
       IF( .NOT. ALLOCATED( gasi8 ) ) ALLOCATE( gasi8(L_NTREF,L_NPREF,L_REFVAR,L_NSPECTI,L_NGAUSS) )
       IF( .NOT. ALLOCATED( gasv8 ) ) ALLOCATE( gasv8(L_NTREF,L_NPREF,L_REFVAR,L_NSPECTV,L_NGAUSS) )
       IF( .NOT. ALLOCATED( gasi ) ) ALLOCATE( gasi(L_NTREF,L_PINT,L_REFVAR,L_NSPECTI,L_NGAUSS) )
       IF( .NOT. ALLOCATED( gasv ) ) ALLOCATE( gasv(L_NTREF,L_PINT,L_REFVAR,L_NSPECTV,L_NGAUSS) )
-!-----------------------------------------------------------------------
-!-----------------------------------------------------------------------
+
+      ! display the values
+      print*,''
+      print*,'Correlated-k matrix size:' 
+      print*,'[',L_NTREF,',',L_NPREF,',',L_REFVAR,',',L_NGAUSS,']' 
 
 !=======================================================================
@@ -288,16 +291,18 @@
          read(111,*) gasv8
          close(111)
-	 
+
       else if (callgasvis.and.graybody) then
-!    constant absorption coefficient in visible
+         ! constant absorption coefficient in visible
          write(*,*)"constant absorption coefficient in visible:"
-         kappa_VI=-100000.
+         kappa_VI = -100000.
          call getin("kappa_VI",kappa_VI)
          write(*,*)" kappa_VI = ",kappa_VI
-	 kappa_VI=kappa_VI*1.e4* mugaz * 1.672621e-27	 ! conversion from m^2/kg to cm^2/molecule         
-         gasv8(:,:,:,:,:)=kappa_VI
+	 kappa_VI = kappa_VI * 1.e4 * mugaz * 1.672621e-27	 ! conversion from m^2/kg to cm^2/molecule         
+         gasv8(:,:,:,:,:) = kappa_VI
+
       else
          print*,'Visible corrk gaseous absorption is set to zero.'
-         gasv8(:,:,:,:,:)=0.0
+         gasv8(:,:,:,:,:) = 0.0
+
       endif
 
@@ -319,25 +324,57 @@
          read(111,*) gasi8
          close(111)
+     
+         ! 'fzero' is a currently unused feature that allows optimisation
+         ! of the radiative transfer by neglecting bands where absorption
+         ! is close to zero. As it could be useful in the future, this 
+         ! section of the code has been kept commented and not erased.
+         ! RW 7/3/12.
+
+         do nw=1,L_NSPECTI
+            fzeroi(nw) = 0.
+!            do nt=1,L_NTREF
+!               do np=1,L_NPREF
+!                  do nh=1,L_REFVAR
+!                     do ng = 1,L_NGAUSS
+!                        if(gasi8(nt,np,nh,nw,ng).lt.1.0e-25)then
+!                           fzeroi(nw)=fzeroi(nw)+1.
+!                        endif
+!                     end do
+!                  end do
+!               end do
+!            end do
+!            fzeroi(nw)=fzeroi(nw)/dble(L_NTREF*L_NPREF*L_REFVAR*L_NGAUSS)
+         end do
+
+         do nw=1,L_NSPECTV
+            fzerov(nw) = 0.
+!            do nt=1,L_NTREF
+!               do np=1,L_NPREF
+!                  do nh=1,L_REFVAR
+!                     do ng = 1,L_NGAUSS
+!                        if(gasv8(nt,np,nh,nw,ng).lt.1.0e-25)then
+!                           fzerov(nw)=fzerov(nw)+1.
+!                        endif
+!                     end do
+!                  end do
+!               end do
+!            end do
+!            fzerov(nw)=fzerov(nw)/dble(L_NTREF*L_NPREF*L_REFVAR*L_NGAUSS)
+         end do
 
       else if (graybody) then
-!     constant absorption coefficient in IR
+         ! constant absorption coefficient in IR
          write(*,*)"constant absorption coefficient in InfraRed:"
-         kappa_IR=-100000.
+         kappa_IR = -100000.
          call getin("kappa_IR",kappa_IR)
-         write(*,*)" kappa_IR = ",kappa_IR	 
-         kappa_IR=kappa_IR*1.e4* mugaz * 1.672621e-27	 ! conversion from m^2/kg to cm^2/molecule       
-         gasi8(:,:,:,:,:)=kappa_IR
+         write(*,*)" kappa_IR = ",kappa_IR
+         kappa_IR = kappa_IR * 1.e4 * mugaz * 1.672621e-27	 ! conversion from m^2/kg to cm^2/molecule       
+         gasi8(:,:,:,:,:) = kappa_IR
+
       else
          print*,'Infrared corrk gaseous absorption is set to zero.'
-         gasi8(:,:,:,:,:)=0.0
-      endif
-
-      do nw=1,L_NSPECTI
-         fzeroi(nw) = 0.
-      end do
-
-      do nw=1,L_NSPECTV
-         fzerov(nw) = 0.
-      end do
+         gasi8(:,:,:,:,:) = 0.0
+
+      endif
 
 
@@ -512,14 +549,46 @@
 
 
+!=======================================================================
+!     Initialise the continuum absorption data
 
       do igas=1,ngasmx
-         if(gnom(igas).eq.'H2_')then 
+
+         if(gnom(igas).eq.'N2_')then 
+
+            call interpolateN2N2(100.D+0,250.D+0,17500.D+0,testcont,.true.)
+
+         elseif(gnom(igas).eq.'H2_')then
+
+            ! first do self-induced absorption
             call interpolateH2H2(500.D+0,250.D+0,17500.D+0,testcont,.true.)
-         elseif(gnom(igas).eq.'H2O')then 
-            call interpolateH2Ocont(990.D+0,296.D+0,683.2D+0*2,0.D+0,testcont,.true.)
+            ! then cross-interactions with other gases
+            do jgas=1,ngasmx
+               if(gnom(jgas).eq.'N2_')then 
+                  call interpolateN2H2(592.D+0,278.15D+0,200000.D+0,10000.D+0,testcont,.true.)
+               elseif(gnom(jgas).eq.'He_')then 
+                  call interpolateH2He(500.D+0,250.D+0,200000.D+0,10000.D+0,testcont,.true.)
+               endif
+            enddo
+
+         elseif(gnom(igas).eq.'H2O')then
+
+            ! H2O is special 
+            if(H2Ocont_simple)then
+               call interpolateH2Ocont_PPC(990.D+0,296.D+0,683.2D+0*2,0.D+0,testcont,.true.)
+            else
+               call interpolateH2Ocont_CKD(990.D+0,296.D+0,683.2D+0*2,0.D+0,testcont,.true.)
+            endif
+
          endif
+
       enddo
 
-      !!! DEALLOCATE LOCAL ARRAYS
+      print*,'----------------------------------------------------'
+      print*,'And that`s all we have. It`s possible that other'
+      print*,'continuum absorption may be present, but if it is we'
+      print*,'don`t yet have data for it...'
+      print*,''
+
+!     Deallocate local arrays
       IF( ALLOCATED( gasi8 ) ) DEALLOCATE( gasi8 )
       IF( ALLOCATED( gasv8 ) ) DEALLOCATE( gasv8 )
